## rest-api-client.sh

List of all functions in alphabetic order

### http()

[line: 96](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L96)

### http.addHeader()

```txt

Add a line to the request header

🟩 param  string  line to add, eg "Connection: keep-alive"

```

[line: 682](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L682)

### http.dump()

```txt

Dump information about request and response

no params

```

[line: 577](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L577)

### http.flushCache()

```txt

Flush the cache

no params

```

[line: 842](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L842)

### http.getRequestAge()

```txt

Get age of the response in sec.
It is especially useful after responseImport

no param

returns integer  age of the response in sec

```

[line: 424](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L424)

### http.getRequestTs()

```txt

Get timestamp of the response as a Unix timestamp.

no param

returns string  the timestamp of the response

```

[line: 410](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L410)

### http.getResponse()

```txt

Get response body

no param

returns string  the response body

```

[line: 443](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L443)

### http.getResponseData()

```txt

Get curl data of this request with status, transferred bytes, speed, ...

no param

returns string  the response data

```

[line: 456](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L456)

### http.getResponseHeader()

```txt

Get response header

no param

returns string  the response header

```

[line: 469](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L469)

### http.getResponseRaw()

```txt

Get raw response (not available after import)

no params

no param

```

[line: 482](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L482)

### http.getStatus()

```txt

Get Http status as string OK|Redirect|Error

no params

```

[line: 493](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L493)

### http.getStatuscode()

```txt

Get Http status code of the request as 3 digit number

no params

```

[line: 506](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L506)

### http.help()

```txt

show a help text

no params

```

[line: 853](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L853)

### http.init()

```txt

Initialize the client

Initialize the client for a new request. Call this before any other
function. It will reset all variables.

```

[line: 117](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L117)

### http.isClientError()

```txt

Was the repsonse a client error (4xx)

no params

```

[line: 555](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L555)

### http.isError()

```txt

Was the repsonse a client error (4xx or 5xx)

no params

```

[line: 544](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L544)

### http.isOk()

```txt

Check: was response a 2xx status code?
output is a statuscode if it matches ... or empty
Additionally you can verify the return code

$? -eq 0 means YES
$? -ne 0 means NO

no params

```

[line: 522](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L522)

### http.isRedirect()

```txt

Was the repsonse a redirect?

no params

```

[line: 533](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L533)

### http.isServerError()

```txt

Was the repsonse a client error (5xx)

no params

```

[line: 566](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L566)

### http.loadcfg()

```txt

Load a config file

This function is marked as deprecated.
It will be removed in the future.

🟩 param  string  config file name

Sourcing that file will set the following vars
- RestApiUser
- RestApiPassword
- RestApiBaseUrl
- RestApiDocs

The function will then set the "internal" vars
- http_req__auth
- http_req__fullurl
- http_req__docs

```

[line: 285](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L285)

### http.makeRequest()

```txt

Execute the request

🔹 param  string  optional: method; GET|POST|PUT|DELETE|...
🔹 param  string  optional: full url
🔹 param  string  optional: request body

description:

This function does the following:

1. Check if to use a cache
2. If not cached, make the request
3. If cached, use the cached result

```

[line: 169](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L169)

### http.quit()

```txt

Show error message with last return code and quit with this exitcode

This function is used to quit the script with a meaningful error message
and the exit code of the last command.

The message is printed to STDERR and contains the return code.
If a documentation URL is known, it is printed as a hint.

The exit code is the one of the last command.
To prevent the script from exiting when this function is called from a
sourced file, the exit is commented out.

no params

```

[line: 252](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L252)

### http.responseDelete()

```txt

Delete an exported file; this is especially useful if you use
AUTOFILE functionality

🟩 param  string  filename with stored response

```

[line: 653](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L653)

### http.responseExport()

```txt

Export response to a file

🔹 param  string  optional: custom filename

```

[line: 611](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L611)

### http.responseImport()

```txt

Import a former response from a file

🟩 param  string  filename with stored response

```

[line: 629](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L629)

### http.setAccept()

```txt

set Accept request header and override default

🟩 param  string  accept header value, eg text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8

```

[line: 693](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L693)

### http.setAuth()

```txt

Set basic authentication
Without given parameter, authentication is removed

🔹 param  string  optional: USER:PASSWORD

```

[line: 709](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L709)

### http.setAuthorization()

```txt

Set authentication via Athorization header
Without given parameter, authorization is removed

🔹 param  string  optional: type, eg. Basic|Bearer|Negotiate
🔹 param  string  optional: token or encoded user + password

```

[line: 726](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L726)

### http.setBaseUrl()

```txt

Set a base url of an API
Remark: Then use http.setUrl to complet the url to request

🟩 param  string  url

```

[line: 753](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L753)

### http.setBody()

```txt

Set body to send for PUTs and POSTs

🟩 param  string  body

```

[line: 741](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L741)

### http.setCacheFile()

```txt

Set cache file

🟩 param  string  filename

```

[line: 831](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L831)

### http.setCacheTtl()

```txt

Set cache ttl in seconds

🟩 param  integer  ttl in seconds

```

[line: 820](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L820)

### http.setDebug()

```txt

Enable or disable debug mode

🟩 param  integer  0|1

```

[line: 765](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L765)

### http.setDocs()

[line: 769](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L769)

### http.setFullUrl()

```txt

Set a full url to request

🔹 param  string  optional: url

```

[line: 791](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L791)

### http.setMethod()

```txt

Set the method to use; GET|POST|PUT|DELETE|...

🟩 param  string  name of method

```

[line: 780](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L780)

### http.setUrl()

```txt

Complete the base url

🟩 param  string  url part behind base url

```

[line: 806](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L806)

- - -
Generated with [Bashdoc](https://github.com/axelhahn/bashdoc) v0.6
